@ECHO OFF

REM Configure the drive letter of the memory card/stick where MapSource puts the image file 'gmapsupp.img':
set MemCardDriveLetter=M

REM Set GmapsuppPath to the directory where your image file gmapprom.img should be uploaded from
REM THIS SHOULD NOT BE THE MEMORY CARD AS IT SHOULD BE REMOVED BEFORE UPLOADING!
REM If the directory does not exist, it will be created.  At least we'll try to ...  ;o)
set GmappromPath=C:\Garmin

REM Set WebUpdaterPath to the directory where your WebUpdater is installed - if necessary.
REM This must not be changed if you run the batch file from the WebUpdater's program directory.
set WebUpdaterPath=.

REM ################################################################
REM #####     Nothing left to be configured beyond this line   #####
REM ################################################################

set Gmapsupp=%MemCardDriveLetter%:\Garmin\gmapsupp.img
set Gmapprom=%GmappromPath%\gmapprom.img
set WebUpdater=%WebUpdaterPath%\WebUpdater.exe

echo UPLOADER FOR GARMIN 278 MAPSETS
echo ===============================
echo.
echo This script will upload a Garmin mapset image file to the internal memory of
echo your Garmin GPSMap 278, using Garmin's WebUpdater (which must be installed).
:TryAgain
set answer=x
if exist "%Gmapsupp%" (
    echo.
    echo Found a mapset image file on your memory card/stick:
    echo.
    dir "%Gmapsupp%"
    echo.
    echo Should this image file be copied to your predefined upload path
    set /P answer="'%GmappromPath%'?  (y/n)  [n] "
)
if not exist "%GmappromPath%" (
    mkdir "%GmappromPath%"
)
if "%answer%" EQU "y" (
    echo.
    copy /V /-Y "%Gmapsupp%" "%Gmapprom%"
)
if not exist "%Gmapprom%" (
    echo.
    echo First rename/move the image file created by MapSource [should
    echo be like 'gmapsupp.img'] to your predefined image upload path
    echo '%Gmapprom%'.
    echo.
    echo Press [RETURN] to try again or [Ctrl]-C to abort.
    pause>NUL
    GoTo TryAgain
)
echo.
echo The following image file will be uploaded:
echo.
dir "%Gmapprom%"
echo.
echo WARNING!  The [pre]loaded mapset of your GPSMap 278 will be overwritten!
echo.
set answer=n
set /P answer="Do you really want to upload the mapset? (y/n) [n] "

if "%answer%" NEQ "y" (
    echo.
    echo Ok, nothing will be uploaded.
    GoTo END
)

echo.
echo Prerequisites:
echo ==============
echo.
echo    1. Switch off screensaver.
echo    2. Disable USB Root Hub's energy saving options
echo       [see Device Manager - USB Root Hub - Properties - Energy saving tab]
echo    3. Unplug all USB devices [esp. card reader and printer].
echo    4. Remove the previously used memory card resp. memory stick.
echo    5. Plug your GPS to the external power supply.
echo    6. Connect the GPS to an USB port - don't use USB hubs!
echo    7. Switch the GPS on - do NOT press any buttons!
echo    8. Start uploading by pressing [RETURN] ...
echo.
echo Press [RETURN] to start uploading
echo.
pause >NUL

"%WebUpdater%" /upload_file rgn=49 path="%Gmapprom%" -autorun usb /unlock_check fid=284 pid=1 /i

echo WebUpdater finished with status %ERRORLEVEL% (0=Ok).
echo.
pause

:END
echo.
echo This Window will close automatically in 5 seconds ...
ping -n 5 www.google.de >NUL

set answer=
set GmappromPath=
set Gmapprom=
set GmapsuppPath=
set Gmapsupp=
set WebUpdaterPath=
set WebUpdater=
